<?php

namespace Drupal\discourse_sso\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\EventDispatcher\EventDispatcherInterface;
use Symfony\Component\DependencyInjection\ContainerInterface;
use Drupal\discourse_sso\LoginEvent;
use Symfony\Component\HttpFoundation\RedirectResponse;

/**
 * Discourse SSO controller.
 */
class DiscourseSsoController extends ControllerBase {

  public function discourse_sso() {
    $user = \Drupal::currentUser();
    $payload = isset($_GET['sso']) ? $_GET['sso'] : NULL;
    $sig = isset($_GET['sig']) ? $_GET['sig'] : NULL;
    if (!$payload) {
      $payload = isset($_SESSION['discourse_sso_payload']) ? $_SESSION['discourse_sso_payload'] : NULL;
    }
    if (!$sig) {
      $sig = isset($_SESSION['discourse_sso_sig']) ? $_SESSION['discourse_sso_sig'] : NULL;
    }
    if (!$payload || !$sig) {
      //drupal_access_denied();
	  //drupal_set_message(t('No payload or sig'));
	  discourse_sso_retry();
	  return;
    }
    if ($user->id()) {
      discourse_sso_validate($payload, $sig);
    }
    else {
	  discourse_sso_login($payload, $sig);
    }
  }
}
